unit Snow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MPlayer,mmsystem;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{$R Snow.res}

procedure TForm1.FormCreate(Sender: TObject);
begin
  application.ShowMainForm:=false;
end;

const
  SnowNumber = 250; // ѩ-1
  SnowColor = $FFFFFF;
  num = 11;//ɵĵ
  //ɵĵĵƫ
  SnowShapeX: array[0..num] of integer = (1, -1, 1, -1, 0, 1, 0, -1, 0, 2, 0, -2);
  SnowShapeY: array[0..num] of integer = (1, -1, -1, 1, 1, 0, -1, 0, 2, 0, -2, 0);


type
  SnowNode = record
    Point: TPoint; // ѩλ
    Color: array[0..num] of Integer; // ǰɫ
    Speed: Integer; // 
    nMove: Integer; // 
    Stick: Integer; // 'ճ'
  end;

var
  SnowNodes: array[0..SnowNumber] of SnowNode; // ѩ
  hTimer: Integer; // ''ʱӾ
  CrWind: Integer; // ǰ'' ( -1 ~ 1 )
  CrStep: Integer; // ǰѭ()
  ScreenWidth, ScreenHeight: Integer; // Ļߴ


procedure MusicResToFile(const ResName, ResType, FileName: string);
var
MusicRes: TResourceStream;
begin
  MusicRes := TResourceStream.Create(HInstance, ResName, PChar(ResType));
  try
    MusicRes.SaveToFile(FileName); //ԴΪļԭļ
  finally
    MusicRes.Free;
  end;
end;


  // ȡĻߴ -> ScreenWidth, ScreenHeight
procedure GetScreenSize;
begin
  ScreenWidth := GetSystemMetrics(SM_CXSCREEN);
  ScreenHeight := GetSystemMetrics(SM_CYSCREEN);
end;

  // ''ʱ

procedure TimerProc(hWnd: HWND; uMsg: UINT; idEvent: UINT; dwTime: DWORD); stdcall;
begin
  SetTimer(0, hTimer, (Random(27) + 4) * 250, @TimerProc); // ´ηıʱ
  if (CrWind <> 0) then CrWind := 0 else CrWind := Random(3) - 1; // ޸ķ
end;

  // ʼѩ

procedure InitSnowNodes;
var
  hScreenDc, J, k: Integer;
begin
  hScreenDc := CreateDC('DISPLAY', nil, nil, nil);
  for J := 0 to SnowNumber do
  begin
    SnowNodes[J].Point.X := Random(ScreenWidth);
    SnowNodes[J].Point.Y := Random(ScreenHeight);
    for k := 0 to num do
      SnowNodes[J].Color[k] := GetPixel(hScreenDc, SnowNodes[J].Point.X + SnowShapeX[k], SnowNodes[J].Point.Y + SnowShapeY[k]);
    SnowNodes[J].Speed := Random(5) + 1; // ѭһ (1~5)
    SnowNodes[J].nMove := Random(SnowNodes[J].Speed) + 1; // ÿ(1~5)
    SnowNodes[J].Stick := 30 - Random(SnowNodes[J].Speed); // 'ճ'(ѭһճж)
  end;
  DeleteDC(hScreenDc);
end;

  // ƶѩ ..

procedure MoveSnowNodes;
var
  hScreenDc, I, X, Y, k: Integer;
begin
  hScreenDc := CreateDC('DISPLAY', nil, nil, nil);
  for I := 0 to SnowNumber do
  begin
   // ѩ½
    if (CrStep mod SnowNodes[I].Speed) <> 0 then Continue;
   // ָϴαǵ
    for k := 0 to num do
      if GetPixel(hScreenDc, SnowNodes[I].Point.X + SnowShapeX[k], SnowNodes[I].Point.Y + SnowShapeY[k]) = SnowColor then
        SetPixel(hScreenDc, SnowNodes[I].Point.X + SnowShapeX[k], SnowNodes[I].Point.Y + SnowShapeY[k], SnowNodes[I].Color[k]);
   // ݷƮ
    X := SnowNodes[I].Point.X + Random(3) - 1 + CrWind;
    Y := SnowNodes[I].Point.Y + SnowNodes[I].nMove;
   // ѩ(ͣ)Ч
    if ((CrStep mod SnowNodes[I].Stick) = 0) // ͻѩ ..
      and (GetPixel(hScreenDc, X, Y) <> GetPixel(hScreenDc, X, Y + 1)) // 'Ե'ж
      and (GetPixel(hScreenDc, X - 1, Y) <> GetPixel(hScreenDc, X - 1, Y + 1))
      and (GetPixel(hScreenDc, X + 1, Y) <> GetPixel(hScreenDc, X + 1, Y + 1)) then
    begin
     // ΢
      if GetPixel(hScreenDc, X, Y - 1) = GetPixel(hScreenDc, X, Y - 2) then Dec(Y) // ϱԵ
      else if GetPixel(hScreenDc, X, Y + 1) = GetPixel(hScreenDc, X, Y + 2) then Inc(Y); // ±Ե
      Inc(X, CrWind);
     // (ѩ)
      for k := 0 to num do
        SetPixel(hScreenDc, X + SnowShapeX[k], Y + SnowShapeY[k], SnowColor);
     // ѩ
      SnowNodes[I].Point.Y := Random(10);
      SnowNodes[I].Point.X := Random(ScreenWidth);
      for k := 0 to num do
        SnowNodes[I].Color[k] := GetPixel(hScreenDc, SnowNodes[I].Point.X + SnowShapeX[k], SnowNodes[I].Point.Y + SnowShapeY[k]);
    end else
    begin
      if (X < 0) or (X > ScreenWidth) or (Y > ScreenHeight) then // Χѩ
      begin
        SnowNodes[I].Point.Y := Random(10);
        SnowNodes[I].Point.X := Random(ScreenWidth);
        for k := 0 to num do
          SnowNodes[I].Color[k] := GetPixel(hScreenDc, SnowNodes[I].Point.X + SnowShapeX[k], SnowNodes[I].Point.Y + SnowShapeY[k]);
      end else
      begin
       // ɫѩ
        for k := 0 to num do
        begin
          SnowNodes[I].Color[k] := GetPixel(hScreenDc, X + SnowShapeX[k], Y + SnowShapeY[k]);
          SetPixel(hScreenDc, X + SnowShapeX[k], Y + SnowShapeY[k], SnowColor);
        end;
       // ʱѩλ
        SnowNodes[I].Point.X := X;
        SnowNodes[I].Point.Y := Y;
      end;
    end;
  end;
  DeleteDC(hScreenDc);
  Inc(CrStep);
end;

var
  ThreadMsg: TMsg; // ׼Ϣṹ
  Frequency: Int64; // ܶʱƵ
  StartCt, EndCt: Int64; // ܶʱ
  ElapsedTime: Extended; // ʱ
  Buf:Array[0..20] of char;

begin
  Randomize; GetScreenSize; InitSnowNodes; // ʼ
  QueryPerformanceFrequency(Frequency); // ܶʱƵ
  hTimer := SetTimer(0, 0, Random(5) * 250, @TimerProc); // װʱ
  RegisterHotKey(0, 0, MOD_CONTROL, ORD('L')); // ע˳ȼ Ctrl+L

  MessageBox(0,'[ȷ]ѩ׷ɣһֱ[Ctrl]+[L]ѩ', 'ѩЯ',MB_OK);

  MusicResToFile('Music', 'Midi', 'Snow.mid');
  MCISendString(pchar('OPEN Snow.mid TYPE SEQUENCER ALIAS NN'), '', 0, 0);
  MCISendString('PLAY NN FROM 0', '', 0, 0);
  MCISendString('CLOSE ANIMATION', '', 0, 0);

  while TRUE do // Ϣѭ
  begin
    QueryPerformanceCounter(StartCt); // ִǰ ֵ
    application.ProcessMessages;
    Sleep(2);
    if PeekMessage(ThreadMsg, 0, 0, 0, PM_REMOVE) then // ȡϢ
    begin
      case ThreadMsg.message of
        WM_TIMER:
          TimerProc(0, 0, 0, 0); // Ԥıʱѵ

        WM_HOTKEY:
          begin
            KillTimer(0, hTimer); // ɾʱ
            UnregisterHotKey(0, 0); // ɾ˳ȼ Ctrl+L
            InvalidateRect(0, nil, TRUE); // ˢĻ
            MCISendString('CLOSE NN', '', 0, 0);
            DeleteFile('Snow.mid');
            Application.Terminate;
            Exit;
            Break; // Ϣѭ
           end;

        WM_DISPLAYCHANGE:
          begin
            GetScreenSize; // ȡĻߴ
            InitSnowNodes; // ʼѩ
          end;
      end;
    end;
    MciSendString('Status NN mode',buf,20,0);
    if strpas(buf)='stopped' then
    begin
      MciSendString('seek NN start','',0,0);
      MciSendString('play NN From 0','',0,0);
    end;
    MoveSnowNodes; // ƶѩ
    QueryPerformanceCounter(EndCt); // ִֵ
    ElapsedTime := (EndCt-StartCt)/Frequency; 
    if (ElapsedTime < 0.0005) then Sleep(2) // 
    else if (ElapsedTime < 0.0010) then Sleep(1)
         else if (ElapsedTime < 0.0015) then Sleep(0);
  end;
end.

